#include <iostream>
#include <pthread.h>

#define COUNTER_TRESHOLD 100
#define COUNTER 0
#define HAMMER 1
#define SCREW_DRIVER 2
#define SAW 3
#define MUTEXES_COUNT 4
#define THREADS_COUNT 3
#define WORK_ITERATIONS 1000000

using namespace std;

typedef struct argsStruct_t{
    pthread_mutex_t *counterMutex;
    int *counter;
    pthread_mutex_t *tool1;
    string tool1Name;
    pthread_mutex_t *tool2;
    string tool2Name;
    int threadID;
};

void work()
{
    for (int i = 0; i < WORK_ITERATIONS; i++);
}

void* guyThread(void *args)
{
    argsStruct_t *tool = (argsStruct_t *)args;
    while(true) {
        pthread_mutex_lock(tool->tool1);
        cout << "Guy " <<tool->threadID << " borrowed " << tool->tool1Name << "." << endl;
        work();
        pthread_mutex_lock(tool->tool2);
        cout << "Guy " << tool->threadID << " borrowed " << tool->tool2Name << "." << endl;
        work();
        pthread_mutex_unlock(tool->tool2);
        pthread_mutex_unlock(tool->tool1);
        if ((*tool->counter) > COUNTER_TRESHOLD)
            break;
        pthread_mutex_lock(tool->counterMutex);
        (*tool->counter)++;
        pthread_mutex_unlock(tool->counterMutex);
    }
    return 0;
}

int main() {
    pthread_t threadGuy[THREADS_COUNT];
    pthread_mutex_t mutexes[MUTEXES_COUNT];
    int counter = 0;
    argsStruct_t threadTools[THREADS_COUNT];
    threadTools[0] = {&mutexes[COUNTER], &counter, &mutexes[HAMMER], "hammer", &mutexes[SCREW_DRIVER], "screw driver", 0};
    threadTools[1] = {&mutexes[COUNTER], &counter, &mutexes[SCREW_DRIVER], "screw driver", &mutexes[SAW], "saw", 1};
    threadTools[2] = {&mutexes[COUNTER], &counter, &mutexes[SAW], "saw", &mutexes[HAMMER], "hammer", 2};

    for(int i = 0; i < MUTEXES_COUNT; i++)
        pthread_mutex_init(&mutexes[i], NULL);
    for(int i = 0; i < THREADS_COUNT; i++)
        pthread_create(&threadGuy[i], NULL, guyThread, (void *) &threadTools[i]);
    for(int i = 0; i < THREADS_COUNT; i++)
        pthread_join(threadGuy[i], NULL);
    for(int i = 0; i < MUTEXES_COUNT; i++)
        pthread_mutex_destroy(&mutexes[i]);
    return 0;
}